/* Diese Datei kann man zum statischen Binden in C/C++-Programme verwenden
   Oder aber mittels LoadLibrary + GetProcAddress
 220705	heha: erstellt, 
 221107	heha: Komplett gendert: Kunde will nur Datenpaar
	(Weg und Kradtsto) bei detektiertem Einschlag;
	<float> (nicht <double>) ist tatschlich Kundenwunsch
 221110	heha: Kraftmessung nun doch ohne Jumper, also bis 40 kN.
	Verwendung einer Linearisierung, gleitende Null,
	neuer Name (Kundenwunsch, kann man das nicht vorher festlegen??)
 230316	Anpassung an erheblich genderte Firmware
 230331	Nochmal Anpassung an (mittlerweile funktionierendes) Wegmesspoti
*/
#pragma once
#include <windows.h>	// BYTE, HWND

#ifdef IMPACTAPP_DLL
# ifdef _M_X64		// Dann Export (nur) per DEF-Datei erspart Warnung LNK4197
#  define FUNC(x) EXTERN_C x _stdcall
# else
#  define FUNC(x) EXTERN_C __declspec(dllexport) x _stdcall
# endif
#else
# define FUNC(x) EXTERN_C __declspec(dllimport) x _stdcall
#endif

#ifdef __cplusplus
# define REF &
# define DEF(x) =x
#else
# define REF *const
# define DEF(x)
#endif

#if defined(__cplusplus) && !defined(IMPACTAPP_DLL)
namespace impactapp{	// Fr den DLL-Anwender in C++ die Aufrufe in einen Namespace stecken
#endif

// v: 0 = Bremse gelst | 1 = Bremse voll angezogen | NaN = Bremse an Potenziometer bergeben
// ret: OK wenn's geklappt hat
FUNC(bool) setBrake(float v);

struct Ergebnis{// <float> (nicht <double>) als Wunsch des Anwenders
 float poti;	// (Mittlere) Potenziometerstellung, 0=Linksanschlag, 1 = Rechtsanschlag
 float pos;	// Position (absolut, vom Poti) in mm
 float weg;	// Weg (bei Einschlag positiv, vom Poti, nach 4 ms) in mm
 float stoss;	// Kraftsto in Ns = Impuls = Integral des Kraftverlaufs (der positiven Anteile in der ersten ms)
 float maxkraft;// Gipfelpunkt des Kraftverlaufs in N
};

// ret: ob es funktioniert hat
//	Bit 0 fr Position gendert (300 ms)
//	Bit 1 fr Verdreh-Mikrotaster gendert
//	Bit 2 fr Kraftsto detektiert (Trigger)
//	Bit 3 = Stellung des Verdreh-Mikrotasters
//	Bit 4 fr Statistikwerte gendert (100 ms)
//	Bit 7 fr Gert angesteckt und funktionsbereit

FUNC(BYTE) Poll(Ergebnis REF);
// Diese Routine kmmert sich um das stete Nachstellen des Triggerpegels.
// Kehrt sofort zurck und meldet die o.a. Bits

// Hilfsfunktion zum Debuggen:
// 1. ComboBoxEx mit gefundenen HID-Gerten auffllen
// 2. <hComboBoxEx>==0: HID-Gert Index <index> erneut ffnen/verbinden
FUNC(void) Enum(HWND hComboEx DEF(0),int index DEF(0));

// Hilfsfunktion zum Debuggen:
// Oszillogramm des Kraftstoes abholen, <dt> = Sample-Intervall
FUNC(int) getCurve(float*buffer,int buflen DEF(1716),float*dt DEF(0));

#if defined(__cplusplus) && !defined(IMPACTAPP_DLL)
}//namespace
#endif
