#include "impactapp.h"
#include <windowsx.h>
#include <tchar.h>	// _sntprintf
#include <stdio.h>	// sprintf

#pragma intrinsic(memcpy,memset,strcpy,strlen)

HINSTANCE hInstance;
#define elemof(x) (sizeof(x)/sizeof((x)[0]))
#define T(x) TEXT(x)

struct RECTS{
 short left,top,right,bottom;
 inline short width() {return right-left;}
 inline short height() {return bottom-top;}
 void operator=(const RECT&r) {
  left=short(r.left);
  top=short(r.top);
  right=short(r.right);
  bottom=short(r.bottom);
 }
 void swapRECT(RECT&r) {
  LONG i;
  i=r.left;   r.left=left;     left=short(i);
  i=r.top;    r.top=top;       top=short(i);
  i=r.right;  r.right=right;   right=short(i);
  i=r.bottom; r.bottom=bottom; bottom=short(i);
 }
};

static struct Config{
 RECTS WinPos;		// Fensterposition des Dialogs
 char cShow;
 BYTE HidNo;		// Nummer des HID-USB, 0 = erstes
 bool load();
 bool save();
}config;

bool Config::load() {
 bool ret=false;
 HKEY k1;
 if (!RegOpenKeyEx(HKEY_CURRENT_USER,T("Software\\h#s"),0,KEY_READ,&k1)) {
  HKEY k2;
  if (!RegOpenKeyEx(k1,T("impactapp"),0,KEY_READ,&k2)) {
   DWORD sz=sizeof*this;
   if (!RegQueryValueEx(k2,T("Config"),0,0,(BYTE*)this,&sz)
   && sz==sizeof*this) ret=true;
  }
 }
 return ret;
}

bool Config::save() {
 bool ret=false;
 HKEY k1;
 DWORD d;
 if (!RegCreateKeyEx(HKEY_CURRENT_USER,T("Software\\h#s"),0,0,0,KEY_READ|KEY_WRITE,0,&k1,&d)) {
  if (d==REG_CREATED_NEW_KEY
  || RegQueryValueEx(k1,0,0,0,0,0)) {	// Keine Beschreibung fr "h#s"?
   TCHAR buf[256];
   int len=LoadString(hInstance,1,buf,elemof(buf));
   RegSetValueEx(k1,0,0,REG_SZ,(BYTE*)buf,(len+1)*sizeof(TCHAR));	// Beschreibung nachreichen
  }
  HKEY k2;
  if (!RegCreateKeyEx(k1,T("impactapp"),0,0,0,KEY_READ|KEY_WRITE,0,&k2,&d)) {
   if (d==REG_CREATED_NEW_KEY
   || RegQueryValueEx(k2,0,0,0,0,0)) {	// Keine Beschreibung fr "impactapp"?
    TCHAR buf[256];
    int len=LoadString(hInstance,2,buf,elemof(buf));
    RegSetValueEx(k2,0,0,REG_SZ,(BYTE*)buf,(len+1)*sizeof(TCHAR));	// Beschreibung nachreichen
   }
   if (!RegSetValueEx(k2,T("Config"),0,REG_BINARY,(BYTE*)this,sizeof*this)) ret=true;
  }
 }
 return ret;
}

TCHAR sDecimal[]=T(".");
TCHAR sTime[]=T(":");
bool iMeasure;

INT_PTR CALLBACK MainDlgProc(HWND Wnd,UINT msg, WPARAM wParam, LPARAM lParam) {
 static POINT minSize;		// Dialogresource = minimale Tracking-Gre
 switch (msg) {
  case WM_INITDIALOG:{
   WINDOWPLACEMENT wp;
   wp.length=sizeof wp;
   GetWindowPlacement(Wnd,&wp);
   RECT&normal=wp.rcNormalPosition;
   minSize.x=normal.right-normal.left;
   minSize.y=normal.bottom-normal.top;
   if (config.load()) {
    config.WinPos.swapRECT(normal);	// alte Gre retten, neue Gre setzen
    SetWindowPlacement(Wnd,&wp);
   }else{
    config.WinPos=normal;		// vorhandene Gre einsetzen
    config.cShow=SW_SHOW;
   }
   impactapp::Enum(GetDlgItem(Wnd,101),config.HidNo);
//   ShowWindow(Wnd,config.cShow);
   SendMessage(Wnd,WM_WININICHANGE,0,0);
   SetTimer(Wnd,100,20,0);
  }return TRUE;
  case WM_WININICHANGE: {
   GetProfileString(T("Intl"),T("sDecimal"),sDecimal,sDecimal,elemof(sDecimal));
   GetProfileString(T("Intl"),T("sTime"),sTime,sTime,elemof(sTime));
   iMeasure=!!GetProfileInt(T("Intl"),T("iMeasure"),0);
  }break;
  case WM_GETMINMAXINFO: {
   MINMAXINFO&mmi=*(MINMAXINFO*)lParam;
   mmi.ptMinTrackSize=minSize;	// Struct kopieren
  }break;
  case WM_SIZE: switch (wParam) {
   case SIZE_RESTORED: config.cShow=SW_SHOW; break;
   case SIZE_MAXIMIZED: config.cShow=SW_MAXIMIZE; break;
   case SIZE_MINIMIZED: config.cShow=SW_MINIMIZE; break;
  }//nobreak
  case WM_MOVE: if (config.cShow==SW_SHOW) {
   RECT rw;
   GetWindowRect(Wnd,&rw);	// Window-Rechteck, nicht Client-Rechteck!
   int dX=rw.right-rw.left-config.WinPos.width(),
       dY=rw.bottom-rw.top-config.WinPos.height();
   if (dX|dY) {
    RECT ref;		// Bezugsrechteck zur Skalierung
    GetWindowRect(GetDlgItem(Wnd,102),&ref);	// Plot in der Mitte, grenvernderlich
    MapWindowPoints(0,Wnd,(POINT*)&ref,2);
    HDWP dwp=BeginDeferWindowPos(10);
    for (HWND w=GetFirstChild(Wnd);w;w=GetNextSibling(w)) {
     RECT r;
     GetWindowRect(w,&r);		// Problem: Falsche Hhe bei ComboBox(Ex)!
     r.right-=r.left; r.bottom-=r.top;	// ab hier .right = Breite und .bottom = Hhe
     ScreenToClient(Wnd,(POINT*)&r);		// Nur .left/.top transformieren
     BYTE moveSide=0;
     if (r.left<=ref.left && r.left+r.right>=ref.right) moveSide|=2;	// gleich oder umschlieend: Gre ndern
     else if (r.left>=ref.right) moveSide|=1;				// rechts daneben: schieben
     if (r.top<=ref.top && r.top+r.bottom>=ref.bottom) moveSide|=8;	// gleich oder umschlieend: Gre ndern
     else if (r.top>=ref.bottom) moveSide|=4;				// darunter: schieben
     if (GetDlgCtrlID(w)==108) moveSide|=8;	// Listbox (als Ausnahme, nicht umschlieend): Y-Gre ndern
     // (Darf nicht IntegralHeight sein, sonst geht's schief!)
     if (moveSide) {
      if (moveSide&1) r.left+=dX;
      if (moveSide&2) r.right+=dX;
      if (moveSide&4) r.top+=dY;
      if (moveSide&8) r.bottom+=dY;
      dwp=DeferWindowPos(dwp,w,0,r.left,r.top,r.right,r.bottom,
      SWP_NOZORDER
      | (moveSide&0x5?0:SWP_NOMOVE)
      | (moveSide&0xA?0:SWP_NOSIZE));
     }
    }
    EndDeferWindowPos(dwp);	// Client-Fenster verschieben oder resizen
   }
   config.WinPos=rw;
  }break;
  case WM_TIMER: switch (wParam) {
   case 100: {
    impactapp::Ergebnis erg;
    BYTE ret=impactapp::Poll(erg);
    if (!(ret&0x80)) {
     KillTimer(Wnd,wParam);	// Verbindung verloren
     break;
    }
    if (ret&0x37) {	// irgendwas fruchtbares
     CheckDlgButton(Wnd,103,ret&8?BST_CHECKED:BST_UNCHECKED);	// Verdreh-Taster
     TCHAR s[40];
     if (ret&1) {			// Messschieber-Wert? (300 ms)
      s[_sntprintf(s,elemof(s)-1,T("%.*f %s"),
	iMeasure?3:2,			// Kommastellen
	iMeasure?erg.pos/25.4:erg.pos,	// Anzeigewert
	iMeasure?T("in"):T("mm"))]=0;	// Einheit
      TCHAR*p=_tcschr(s,'.');
      if (p) *p=*sDecimal;		// Dezimaltrenner ersetzen
      SetDlgItemText(Wnd,106,s);	// Wert vom Messschieber
     }
     if (ret&16) {			// Statistikwerte gendert? (100 ms)
      s[_sntprintf(s,elemof(s)-1,T("%.1f %%"),
	erg.poti*100)]=0;
      TCHAR*p=_tcschr(s,'.');
      if (p) *p=*sDecimal;
      SetDlgItemText(Wnd,104,s);	// Wert vom Hand-Potenziometer
     }
     if (ret&4) {		// Schlag detektiert
      s[_sntprintf(s,elemof(s)-1,T("%.2f mm / %.1f mNs / %.2f kN"),
	erg.weg,
	erg.stoss*1000,
	erg.maxkraft*0.001)]=0;
      SetDlgItemText(Wnd,105,s);
      SendDlgItemMessage(Wnd,108,LB_ADDSTRING,0,(LPARAM)s);
     }
    }
   }break;
  }break;
  case WM_COMMAND: switch (wParam) {
   case 110: {			// Button "connect/disconnect"
//    if (hips.hDev) hips.close();
//    else hips.open();
//    TCHAR s[32];
//    LoadString(hInstance,hips.hDev?4:3,s,elemof(s));
//    SetWindowText((HWND)lParam,s);
   }break;
   case 111: {			// Urlader anspringen
    DebugBreak();
   }break;
   case IDOK:
   case IDCANCEL: {
    config.save();
    EndDialog(Wnd,wParam);
   }break;
  }break;
 }
 return FALSE;
}

void CALLBACK WinMainCRTStartup(HINSTANCE hInst,HINSTANCE,TCHAR*) {
 hInstance=hInst;
 ExitProcess(UINT(DialogBox(0,MAKEINTRESOURCE(100),0,MainDlgProc)));
}

extern "C" BYTE _fltused;
BYTE _fltused;
